import { JSONSchema6 } from 'json-schema';
import { FilterSignature } from '.';
export declare const FULL_TEXT_SLUG = "full_text_search";
export declare const filter: (filters: JSONSchema6 | JSONSchema6[], collection: any[]) => any[];
export declare const createFullTextSearchFilter: (schema: JSONSchema6, term: string) => JSONSchema6;
export declare const upsertFullTextSearch: (schema: JSONSchema6, filters: JSONSchema6[] | undefined, term: string) => JSONSchema6[];
export declare const removeFullTextSearch: (filters: JSONSchema6[]) => JSONSchema6[];
export declare const createFilter: (schema: JSONSchema6, signatures: FilterSignature[]) => JSONSchema6;
export declare const decodeFilter: (schema: JSONSchema6, filter: JSONSchema6) => ({} | null)[];
export declare const getOperators: (schema: JSONSchema6, field: string) => {
    slug: string;
    label: any;
}[];
export declare const flattenSchema: (schema: JSONSchema6, delimiter?: string) => JSONSchema6;
export declare const unflattenSchema: (schema: JSONSchema6, delimiter?: string) => JSONSchema6;
