import * as React from 'react';
import { DefaultProps, RenditionSystemProps } from '../common-types';
interface InternalHeadingProps extends DefaultProps {
    align?: boolean;
    monospace?: boolean;
    caps?: boolean;
    bold?: boolean;
}
export declare type HeadingProps = InternalHeadingProps & RenditionSystemProps;
declare const Base: React.FunctionComponent<HeadingProps> & {
    h1: React.FunctionComponent<HeadingProps>;
    h2: React.FunctionComponent<HeadingProps>;
    h3: React.FunctionComponent<HeadingProps>;
    h4: React.FunctionComponent<HeadingProps>;
    h5: React.FunctionComponent<HeadingProps>;
    h6: React.FunctionComponent<HeadingProps>;
};
export default Base;
