import * as React from 'react';
import { DefaultProps, RenditionSystemProps, Sizing } from '../common-types';
export interface InternalSelectProps extends DefaultProps, Sizing {
    value?: string | string[] | number | null;
    disabled?: boolean;
    onChange?: React.ChangeEventHandler<HTMLSelectElement>;
}
export declare type SelectProps = InternalSelectProps & RenditionSystemProps;
declare const _default: React.FunctionComponent<SelectProps>;
export default _default;
